diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java b/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
index 18840ac6d..88681190c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScrolledSelectionList.java
@@ -1,10 +1,13 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 public abstract class ScrolledSelectionList {
     private final Minecraft minecraft;
@@ -25,17 +28,17 @@ public abstract class ScrolledSelectionList {
     private int headerHeight;
 
     public ScrolledSelectionList(Minecraft minecraft, int width, int height, int y0, int y1, int itemHeight) {
-        yDrag = -2F;
-        selectedElement = -1;
-        lastClicked = 0L;
-        renderSelection = true;
+        this.yDrag = -2F;
+        this.selectedElement = -1;
+        this.lastClicked = 0L;
+        this.renderSelection = true;
         this.minecraft = minecraft;
         this.width = width;
         this.height = height;
         this.y0 = y0;
         this.y1 = y1;
         this.itemHeight = itemHeight;
-        x1 = width;
+        this.x1 = width;
     }
 
     public void setRenderSelection(boolean renderSelection) {
@@ -57,14 +60,14 @@ public abstract class ScrolledSelectionList {
     protected abstract boolean isSelectedItem(int itemIndex);
 
     protected int getMaxPosition() {
-        return getItemCount() * itemHeight + headerHeight;
+        return getItemCount() * this.itemHeight + this.headerHeight;
     }
 
     protected abstract void renderHoleBackground();
 
-    protected abstract void renderItem(int index, int x, int y, int height, Tessellator tessellator);
+    protected abstract void renderItem(int index, int x, int y, int height, TessellatorGeneral tessellator);
 
-    protected void renderHeader(int x, int y, Tessellator tessellator) {
+    protected void renderHeader(int x, int y, TessellatorGeneral tessellator) {
     }
 
     protected void clickedHeader(int x, int y) {
@@ -74,10 +77,10 @@ public abstract class ScrolledSelectionList {
     }
 
     public int getItemAtPosition(int x, int y) {
-        int xMin = width / 2 - 110;
-        int xMax = width / 2 + 110;
-        int yMin = ((y - y0 - headerHeight) + (int) amountScrolled) - 4;
-        int yMax = yMin / itemHeight;
+        int xMin = this.width / 2 - 110;
+        int xMax = this.width / 2 + 110;
+        int yMin = ((y - this.y0 - this.headerHeight) + (int) this.amountScrolled) - 4;
+        int yMax = yMin / this.itemHeight;
         if (x >= xMin && x <= xMax && yMax >= 0 && yMin >= 0 && yMax < getItemCount()) {
             return yMax;
         } else {
@@ -86,204 +89,204 @@ public abstract class ScrolledSelectionList {
     }
 
     private void capYPosition() {
-        int maxAmountScrolled = getMaxPosition() - (y1 - y0 - 4);
+        int maxAmountScrolled = getMaxPosition() - (this.y1 - this.y0 - 4);
         if (maxAmountScrolled < 0) {
             maxAmountScrolled /= 2;
         }
-        if (amountScrolled < 0.0F) {
-            amountScrolled = 0.0F;
+        if (this.amountScrolled < 0.0F) {
+            this.amountScrolled = 0.0F;
         }
-        if (amountScrolled > (float) maxAmountScrolled) {
-            amountScrolled = maxAmountScrolled;
+        if (this.amountScrolled > (float) maxAmountScrolled) {
+            this.amountScrolled = maxAmountScrolled;
         }
     }
 
     public void render(int x, int y, float partialTicks) {
         renderHoleBackground();
         int numItems = getItemCount();
-        int scrollbarLeft = width / 2 + 124;
+        int scrollbarLeft = this.width / 2 + 124;
         int scrollbarRight = scrollbarLeft + 6;
-        if (minecraft.controllerInput != null) {
-            if (Math.abs(minecraft.controllerInput.joyRight.getY()) > 0.1f) {
-                amountScrolled += minecraft.controllerInput.joyRight.getY();
+        if (this.minecraft.controllerInput != null) {
+            if (Math.abs(this.minecraft.controllerInput.joyRight.getY()) > 0.1f) {
+                this.amountScrolled += this.minecraft.controllerInput.joyRight.getY();
             }
         }
-        if (Mouse.isButtonDown(0) || (minecraft.controllerInput != null && minecraft.controllerInput.buttonA.isPressed())) {
-            if (yDrag == -1F) {
+        if (Mouse.isButtonDown(0) || (this.minecraft.controllerInput != null && this.minecraft.controllerInput.buttonA.isPressed())) {
+            if (this.yDrag == -1F) {
                 boolean flag = true;
-                if (y >= y0 && y <= y1) {
-                    int left = width / 2 - 110;
-                    int right = width / 2 + 110;
-                    int i2 = ((y - y0 - headerHeight) + (int) amountScrolled) - 4;
-                    int k2 = i2 / itemHeight;
+                if (y >= this.y0 && y <= this.y1) {
+                    int left = this.width / 2 - 110;
+                    int right = this.width / 2 + 110;
+                    int i2 = ((y - this.y0 - this.headerHeight) + (int) this.amountScrolled) - 4;
+                    int k2 = i2 / this.itemHeight;
                     if (x >= left && x <= right && k2 >= 0 && i2 >= 0 && k2 < numItems) {
-                        boolean flag1 = k2 == selectedElement && System.currentTimeMillis() - lastClicked < 250L;
+                        boolean flag1 = k2 == this.selectedElement && System.currentTimeMillis() - this.lastClicked < 250L;
                         selectItem(k2, flag1);
-                        selectedElement = k2;
-                        lastClicked = System.currentTimeMillis();
+                        this.selectedElement = k2;
+                        this.lastClicked = System.currentTimeMillis();
                     } else if (x >= left && x <= right && i2 < 0) {
-                        clickedHeader(x - left, ((y - y0) + (int) amountScrolled) - 4);
+                        clickedHeader(x - left, ((y - this.y0) + (int) this.amountScrolled) - 4);
                         flag = false;
                     }
                     if (x >= scrollbarLeft && x <= scrollbarRight && getMaxPosition() != 0) {
-                        scrollMultiplier = -1F;
-                        int i3 = getMaxPosition() - (y1 - y0 - 4);
+                        this.scrollMultiplier = -1F;
+                        int i3 = getMaxPosition() - (this.y1 - this.y0 - 4);
                         if (i3 < 1) {
                             i3 = 1;
                         }
-                        int l3 = (int) ((float) ((y1 - y0) * (y1 - y0)) / (float) getMaxPosition());
+                        int l3 = (int) ((float) ((this.y1 - this.y0) * (this.y1 - this.y0)) / (float) getMaxPosition());
                         if (l3 < 32) {
                             l3 = 32;
                         }
-                        if (l3 > y1 - y0 - 8) {
-                            l3 = y1 - y0 - 8;
+                        if (l3 > this.y1 - this.y0 - 8) {
+                            l3 = this.y1 - this.y0 - 8;
                         }
-                        scrollMultiplier /= (float) (y1 - y0 - l3) / (float) i3;
+                        this.scrollMultiplier /= (float) (this.y1 - this.y0 - l3) / (float) i3;
                     } else {
-                        scrollMultiplier = 1.0F;
+                        this.scrollMultiplier = 1.0F;
                     }
                     if (flag) {
-                        yDrag = y;
+                        this.yDrag = y;
                     } else {
-                        yDrag = -2F;
+                        this.yDrag = -2F;
                     }
                 } else {
-                    yDrag = -2F;
+                    this.yDrag = -2F;
                 }
-            } else if (yDrag >= 0.0F) {
-                amountScrolled -= ((float) y - yDrag) * scrollMultiplier;
-                yDrag = y;
+            } else if (this.yDrag >= 0.0F) {
+                this.amountScrolled -= ((float) y - this.yDrag) * this.scrollMultiplier;
+                this.yDrag = y;
             }
         } else {
-            yDrag = -1F;
+            this.yDrag = -1F;
         }
-        amountScrolled -= Mouse.getDWheel() * 20f;
+        this.amountScrolled -= Mouse.getDWheel() * 20f;
 
         capYPosition();
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_FOG);
-        Tessellator tessellator = Tessellator.instance;
-        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.globalSetLightEnabled(false);
+//        GL11.glDisable(GL11.GL_FOG);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        this.minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float f1 = 32F;
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0x202020);
-        tessellator.addVertexWithUV(x0, y1, 0.0D, (float) x0 / f1, (float) (y1 + (int) amountScrolled) / f1);
-        tessellator.addVertexWithUV(x1, y1, 0.0D, (float) x1 / f1, (float) (y1 + (int) amountScrolled) / f1);
-        tessellator.addVertexWithUV(x1, y0, 0.0D, (float) x1 / f1, (float) (y0 + (int) amountScrolled) / f1);
-        tessellator.addVertexWithUV(x0, y0, 0.0D, (float) x0 / f1, (float) (y0 + (int) amountScrolled) / f1);
+        tessellator.setColorOpaque1i(0x202020);
+        tessellator.addVertexWithUV(this.x0, this.y1, 0.0D, (float) this.x0 / f1, (float) (this.y1 + (int) this.amountScrolled) / f1);
+        tessellator.addVertexWithUV(this.x1, this.y1, 0.0D, (float) this.x1 / f1, (float) (this.y1 + (int) this.amountScrolled) / f1);
+        tessellator.addVertexWithUV(this.x1, this.y0, 0.0D, (float) this.x1 / f1, (float) (this.y0 + (int) this.amountScrolled) / f1);
+        tessellator.addVertexWithUV(this.x0, this.y0, 0.0D, (float) this.x0 / f1, (float) (this.y0 + (int) this.amountScrolled) / f1);
         tessellator.draw();
-        int ix = width / 2 - 92 - 16;
-        int j2 = (y0 + 4) - (int) amountScrolled;
-        if (renderHeader) {
+        int ix = this.width / 2 - 92 - 16;
+        int j2 = (this.y0 + 4) - (int) this.amountScrolled;
+        if (this.renderHeader) {
             renderHeader(ix, j2, tessellator);
         }
         for (int itemIndex = 0; itemIndex < numItems; itemIndex++) {
-            int iy = j2 + itemIndex * itemHeight + headerHeight;
-            int height = itemHeight - 4;
-            if (iy > y1 || iy + height < y0) {
+            int iy = j2 + itemIndex * this.itemHeight + this.headerHeight;
+            int height = this.itemHeight - 4;
+            if (iy > this.y1 || iy + height < this.y0) {
                 continue;
             }
-            if (renderSelection && isSelectedItem(itemIndex)) {
-                int minX = width / 2 - 110;
-                int maxX = width / 2 + 110;
-                GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-                GL11.glDisable(GL11.GL_TEXTURE_2D);
+            if (this.renderSelection && isSelectedItem(itemIndex)) {
+                int minX = this.width / 2 - 110;
+                int maxX = this.width / 2 + 110;
+                GLRenderer.pushFrame();
+                GLRenderer.setShader(Shaders.COLOR);
+                GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
                 tessellator.startDrawingQuads();
-                tessellator.setColorOpaque_I(0x808080);
+                tessellator.setColorOpaque1i(0x808080);
                 tessellator.addVertexWithUV(minX, iy + height + 2, 0.0D, 0.0D, 1.0D);
                 tessellator.addVertexWithUV(maxX, iy + height + 2, 0.0D, 1.0D, 1.0D);
                 tessellator.addVertexWithUV(maxX, iy - 2, 0.0D, 1.0D, 0.0D);
                 tessellator.addVertexWithUV(minX, iy - 2, 0.0D, 0.0D, 0.0D);
-                tessellator.setColorOpaque_I(0);
+                tessellator.setColorOpaque1i(0);
                 tessellator.addVertexWithUV(minX + 1, iy + height + 1, 0.0D, 0.0D, 1.0D);
                 tessellator.addVertexWithUV(maxX - 1, iy + height + 1, 0.0D, 1.0D, 1.0D);
                 tessellator.addVertexWithUV(maxX - 1, iy - 1, 0.0D, 1.0D, 0.0D);
                 tessellator.addVertexWithUV(minX + 1, iy - 1, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
-                GL11.glEnable(GL11.GL_TEXTURE_2D);
+                GLRenderer.popFrame();
             }
             renderItem(itemIndex, ix, iy, height, tessellator);
         }
 
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
+        GLRenderer.disableState(State.DEPTH_TEST);
         byte byte0 = 4;
-        renderHoleBackground(0, y0, 255, 255);
-        renderHoleBackground(y1, height, 255, 255);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL11.GL_ALPHA_TEST);
-        GL11.glShadeModel(GL11.GL_SMOOTH);
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        renderHoleBackground(0, this.y0, 255, 255);
+        renderHoleBackground(this.y1, this.height, 255, 255);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//        GL11.glDisable(GL11.GL_ALPHA_TEST);
+//        GL11.glShadeModel(GL11.GL_SMOOTH);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(0, 0);
-        tessellator.addVertexWithUV(x0, y0 + byte0, 0.0D, 0.0D, 1.0D);
-        tessellator.addVertexWithUV(x1, y0 + byte0, 0.0D, 1.0D, 1.0D);
-        tessellator.setColorRGBA_I(0, 255);
-        tessellator.addVertexWithUV(x1, y0, 0.0D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV(x0, y0, 0.0D, 0.0D, 0.0D);
+        tessellator.setColor2i(0, 0);
+        tessellator.addVertexWithUV(this.x0, this.y0 + byte0, 0.0D, 0.0D, 1.0D);
+        tessellator.addVertexWithUV(this.x1, this.y0 + byte0, 0.0D, 1.0D, 1.0D);
+        tessellator.setColor2i(0, 255);
+        tessellator.addVertexWithUV(this.x1, this.y0, 0.0D, 1.0D, 0.0D);
+        tessellator.addVertexWithUV(this.x0, this.y0, 0.0D, 0.0D, 0.0D);
         tessellator.draw();
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(0, 255);
-        tessellator.addVertexWithUV(x0, y1, 0.0D, 0.0D, 1.0D);
-        tessellator.addVertexWithUV(x1, y1, 0.0D, 1.0D, 1.0D);
-        tessellator.setColorRGBA_I(0, 0);
-        tessellator.addVertexWithUV(x1, y1 - byte0, 0.0D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV(x0, y1 - byte0, 0.0D, 0.0D, 0.0D);
+        tessellator.setColor2i(0, 255);
+        tessellator.addVertexWithUV(this.x0, this.y1, 0.0D, 0.0D, 1.0D);
+        tessellator.addVertexWithUV(this.x1, this.y1, 0.0D, 1.0D, 1.0D);
+        tessellator.setColor2i(0, 0);
+        tessellator.addVertexWithUV(this.x1, this.y1 - byte0, 0.0D, 1.0D, 0.0D);
+        tessellator.addVertexWithUV(this.x0, this.y1 - byte0, 0.0D, 0.0D, 0.0D);
         tessellator.draw();
-        int k3 = getMaxPosition() - (y1 - y0 - 4);
+        int k3 = getMaxPosition() - (this.y1 - this.y0 - 4);
         if (k3 > 0 && getMaxPosition() != 0) {
-            int j4 = ((y1 - y0) * (y1 - y0)) / getMaxPosition();
+            int j4 = ((this.y1 - this.y0) * (this.y1 - this.y0)) / getMaxPosition();
             if (j4 < 32) {
                 j4 = 32;
             }
-            if (j4 > y1 - y0 - 8) {
-                j4 = y1 - y0 - 8;
+            if (j4 > this.y1 - this.y0 - 8) {
+                j4 = this.y1 - this.y0 - 8;
             }
-            int l4 = ((int) amountScrolled * (y1 - y0 - j4)) / k3 + y0;
-            if (l4 < y0) {
-                l4 = y0;
+            int l4 = ((int) this.amountScrolled * (this.y1 - this.y0 - j4)) / k3 + this.y0;
+            if (l4 < this.y0) {
+                l4 = this.y0;
             }
             tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0, 255);
-            tessellator.addVertexWithUV(scrollbarLeft, y1, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(scrollbarRight, y1, 0.0D, 1.0D, 1.0D);
-            tessellator.addVertexWithUV(scrollbarRight, y0, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(scrollbarLeft, y0, 0.0D, 0.0D, 0.0D);
-            tessellator.draw();
-            tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0x808080, 255);
+            tessellator.setColor2i(0, 255);
+            tessellator.addVertexWithUV(scrollbarLeft, this.y1, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, this.y1, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, this.y0, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft, this.y0, 0.0D, 0.0D, 0.0D);
+
+            tessellator.setColor2i(0x808080, 255);
             tessellator.addVertexWithUV(scrollbarLeft, l4 + j4, 0.0D, 0.0D, 1.0D);
             tessellator.addVertexWithUV(scrollbarRight, l4 + j4, 0.0D, 1.0D, 1.0D);
             tessellator.addVertexWithUV(scrollbarRight, l4, 0.0D, 1.0D, 0.0D);
             tessellator.addVertexWithUV(scrollbarLeft, l4, 0.0D, 0.0D, 0.0D);
-            tessellator.draw();
-            tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0xc0c0c0, 255);
-            tessellator.addVertexWithUV(scrollbarLeft, (l4 + j4) - 1, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(scrollbarRight - 1, (l4 + j4) - 1, 0.0D, 1.0D, 1.0D);
-            tessellator.addVertexWithUV(scrollbarRight - 1, l4, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(scrollbarLeft, l4, 0.0D, 0.0D, 0.0D);
+
+            tessellator.setColor2i(0xc0c0c0, 255);
+            tessellator.addVertexWithUV(scrollbarLeft + 1, (l4 + j4) - 1, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, (l4 + j4) - 1, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(scrollbarRight, l4, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(scrollbarLeft + 1, l4, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
         }
         renderDecorations(x, y);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glShadeModel(GL11.GL_FLAT);
-        GL11.glEnable(GL11.GL_ALPHA_TEST);
-        GL11.glDisable(GL11.GL_BLEND);
+        GLRenderer.popFrame();
+//        GL11.glShadeModel(GL11.GL_FLAT);
+//        GL11.glEnable(GL11.GL_ALPHA_TEST);
+        GLRenderer.disableState(State.BLEND);
     }
 
     private void renderHoleBackground(int y0, int y1, int a0, int a1) {
-        Tessellator tessellator = Tessellator.instance;
-        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        this.minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float f = 32F;
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(0x404040, a1);
+        tessellator.setColor2i(0x404040, a1);
         tessellator.addVertexWithUV(0.0D, y1, 0.0D, 0.0D, (float) y1 / f);
-        tessellator.addVertexWithUV(width, y1, 0.0D, (float) width / f, (float) y1 / f);
-        tessellator.setColorRGBA_I(0x404040, a0);
-        tessellator.addVertexWithUV(width, y0, 0.0D, (float) width / f, (float) y0 / f);
+        tessellator.addVertexWithUV(this.width, y1, 0.0D, (float) this.width / f, (float) y1 / f);
+        tessellator.setColor2i(0x404040, a0);
+        tessellator.addVertexWithUV(this.width, y0, 0.0D, (float) this.width / f, (float) y0 / f);
         tessellator.addVertexWithUV(0.0D, y0, 0.0D, 0.0D, (float) y0 / f);
         tessellator.draw();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java b/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
index dc40c1223..d2745a462 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
@@ -1,126 +1,111 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.input.InputType;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.OptionFloat;
 
 public class SliderElement extends ButtonElement {
 
-	public double sliderValue;
-	public boolean dragging;
-	private final OptionFloat option;
-	public IconCoordinate backgroundTexture;
-
-	public SliderElement(int id, int xPosition, int yPosition, OptionFloat optionFloat) {
-		this(id, xPosition, yPosition, 150, 20, optionFloat);
-	}
-
-	public SliderElement(int id, int xPosition, int yPosition, int width, int height, OptionFloat optionFloat) {
-		super(id, xPosition, yPosition, width, height, optionFloat.getDisplayStringValue());
-		this.dragging = false;
-		this.option = optionFloat;
-		this.sliderValue = optionFloat.value;
-	}
-
-	public SliderElement(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
-		super(id, xPosition, yPosition, width, height, text);
-		dragging = false;
-		option = null;
-		sliderValue = defaultValue;
-	}
-
-	@Override
-	protected void setDefaultTextures() {
-		backgroundTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_background");
-		defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider");
-		hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_highlighted");
-		disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_disabled");
-	}
-
-	@Override
-	public void mouseDragged(Minecraft mc, int mouseX, int mouseY) {
-		if(!visible) {
-			return;
-		}
-		if(dragging) {
-			final double realMouseX = mc.inputType == InputType.CONTROLLER ? mc.controllerInput.cursorX : (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
-			sliderValue = MathHelper.clamp((realMouseX - (xPosition + 4)) / (float) (width - 8), 0, 1);
-			if(option != null) {
-				option.set((float) sliderValue);
-				displayString = option.getDisplayString();
-			}
-		}
-	}
-
-	public void drawButton(Minecraft mc, int mouseX, int mouseY)
-	{
-		if (!visible) return;
-
-				boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
-		int state = getButtonState(mouseOver);
-
-		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-
-		IconCoordinate tex;
-		switch (state) {
-			case STATE_DISABLED:
-				tex = disabledTexture;
-				break;
-			case STATE_HOVERED:
-				tex = hoveredTexture;
-				break;
-			case STATE_DEFAULT:
-			default:
-				tex = defaultTexture;
-		}
-
-		// Draw background
-		drawGuiIcon(xPosition, yPosition, width, height, backgroundTexture);
-
-		// Draw foreground
-		drawGuiIcon(xPosition + (int) (sliderValue * (float) (width - 8)), yPosition, 8, height, tex);
-
-		mouseDragged(mc, mouseX, mouseY);
-
-		int textColor;
-		switch (state) {
-			case 0:
-				textColor = 0xA0A0A0;
-				break;
-			case 1:
-				textColor = 0xE0E0E0;
-				break;
-			default:
-				textColor = 0xFFFFA0;
-				break;
-		}
-		drawStringCenteredShadow(mc.font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
-	}
-
-	@Override
-	public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
-		if(super.mouseClicked(mc, mouseX, mouseY)) {
-			final double realMouseX = mc.inputType == InputType.CONTROLLER ? mc.controllerInput.cursorX : (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
-			sliderValue = MathHelper.clamp((realMouseX - (xPosition + 4)) / (float) (width - 8), 0, 1);
-			if(option != null) {
-				option.set((float) sliderValue);
-				displayString = option.getDisplayString();
-			}
-			dragging = true;
-			return true;
-		} else {
-			return false;
-		}
-	}
-
-	@Override
-	public void mouseReleased(int mouseX, int mouseY) {
-		dragging = false;
-	}
+    public double sliderValue;
+    public boolean dragging;
+    private final OptionFloat option;
+    public IconCoordinate backgroundTexture;
+
+    public SliderElement(int id, int xPosition, int yPosition, OptionFloat optionFloat) {
+        this(id, xPosition, yPosition, 150, 20, optionFloat);
+    }
+
+    public SliderElement(int id, int xPosition, int yPosition, int width, int height, OptionFloat optionFloat) {
+        super(id, xPosition, yPosition, width, height, optionFloat.getDisplayStringValue());
+        this.dragging = false;
+        this.option = optionFloat;
+        this.sliderValue = optionFloat.value;
+    }
+
+    public SliderElement(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
+        super(id, xPosition, yPosition, width, height, text);
+        this.dragging = false;
+        this.option = null;
+        this.sliderValue = defaultValue;
+    }
+
+    @Override
+    protected void setDefaultTextures() {
+        this.backgroundTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_background");
+        this.defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider");
+        this.hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_highlighted");
+        this.disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_disabled");
+    }
+
+    @Override
+    public void mouseDragged(Minecraft mc, int mouseX, int mouseY) {
+        if (!this.visible) {
+            return;
+        }
+        if (this.dragging) {
+            final double realMouseX = mc.inputType == InputType.CONTROLLER ? mc.controllerInput.cursorX : (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
+            this.sliderValue = MathHelper.clamp((realMouseX - (this.xPosition + 4)) / (float) (this.width - 8), 0, 1);
+            if (this.option != null) {
+                this.option.set((float) this.sliderValue);
+                this.displayString = this.option.getDisplayString();
+            }
+        }
+    }
+
+    public void drawButton(Minecraft mc, int mouseX, int mouseY) {
+        if (!this.visible) return;
+
+        boolean mouseOver = mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
+        int state = getButtonState(mouseOver);
+
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+
+        IconCoordinate tex = switch (state) {
+            case STATE_DISABLED -> this.disabledTexture;
+            case STATE_HOVERED -> this.hoveredTexture;
+            default -> this.defaultTexture;
+        };
+
+        // Draw background
+        drawGuiIcon(this.xPosition, this.yPosition, this.width, this.height, this.backgroundTexture);
+
+        // Draw foreground
+        drawGuiIcon(this.xPosition + (int) (this.sliderValue * (float) (this.width - 8)), this.yPosition, 8, this.height, tex);
+
+        mouseDragged(mc, mouseX, mouseY);
+
+        int textColor = switch (state) {
+            case 0 -> 0xA0A0A0;
+            case 1 -> 0xE0E0E0;
+            default -> 0xFFFFA0;
+        };
+        drawStringCenteredShadow(mc.font, this.displayString, this.xPosition + this.width / 2, this.yPosition + (this.height - 8) / 2, textColor);
+    }
+
+    @Override
+    public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
+        if (super.mouseClicked(mc, mouseX, mouseY)) {
+            final double realMouseX = mc.inputType == InputType.CONTROLLER ? mc.controllerInput.cursorX : (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
+            this.sliderValue = MathHelper.clamp((realMouseX - (this.xPosition + 4)) / (float) (this.width - 8), 0, 1);
+            if (this.option != null) {
+                this.option.set((float) this.sliderValue);
+                this.displayString = this.option.getDisplayString();
+            }
+            this.dragging = true;
+            return true;
+        } else {
+            return false;
+        }
+    }
+
+    @Override
+    public void mouseReleased(int mouseX, int mouseY) {
+        this.dragging = false;
+    }
 }
